import { EventEmitter, Component, Input, Output, ViewChild, ComponentFactoryResolver, ContentChildren, ViewContainerRef, ViewChildren, NgModule } from '@angular/core';
import { ReactiveFormsModule } from '@angular/forms';
import { DynamicFormControlComponent, DynamicFormLayoutService, DynamicFormValidationService, DynamicFormArrayComponent, DynamicFormControlContainerComponent, DynamicFormComponentService, DynamicFormRelationService, DynamicTemplateDirective, DYNAMIC_FORM_CONTROL_TYPE_ARRAY, DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX, DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP, DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER, DYNAMIC_FORM_CONTROL_TYPE_GROUP, DYNAMIC_FORM_CONTROL_TYPE_INPUT, DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP, DYNAMIC_FORM_CONTROL_TYPE_RATING, DYNAMIC_FORM_CONTROL_TYPE_SELECT, DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA, DYNAMIC_FORM_CONTROL_TYPE_TIMEPICKER, DynamicFormComponent, DynamicFormService, DynamicFormsCoreModule } from '@ng-dynamic-forms/core';
import { BsDatepickerDirective, BsDatepickerModule } from 'ngx-bootstrap/datepicker';
import { TimepickerComponent, TimepickerModule } from 'ngx-bootstrap/timepicker';
import { CommonModule } from '@angular/common';
import { ButtonsModule } from 'ngx-bootstrap/buttons';
import { RatingModule } from 'ngx-bootstrap/rating';
import { TextMaskModule } from 'angular2-text-mask';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapCheckboxComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapCheckboxComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-checkbox",
                template: "<div [formGroup]=\"group\" class=\"form-check\" [class.disabled]=\"model.disabled\">\n\n    <label class=\"form-check-label\">\n\n        <input type=\"checkbox\" class=\"form-check-input\"\n               [checked]=\"model.checked\"\n               [class.is-invalid]=\"showErrorMessages\"\n               [formControlName]=\"model.id\"\n               [id]=\"elementId\"\n               [indeterminate]=\"model.indeterminate\"\n               [name]=\"model.name\"\n               [ngClass]=\"getClass('element', 'control')\"\n               [required]=\"model.required\"\n               [tabindex]=\"model.tabIndex\"\n               [value]=\"model.value\"\n               (blur)=\"onBlur($event)\"\n               (change)=\"onChange($event)\"\n               (focus)=\"onFocus($event)\"/><span [innerHTML]=\"model.label\"\n                                                [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></span>\n    </label>\n\n</div>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapCheckboxComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapCheckboxComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapCheckboxComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapCheckboxComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapCheckboxComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapCheckboxGroupComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
    /**
     * @param {?} model
     * @return {?}
     */
    getCheckboxElementId(model) {
        return this.layoutService.getElementId(model);
    }
}
DynamicNGxBootstrapCheckboxGroupComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-checkbox-group",
                template: "<ng-container [formGroup]=\"group\">\n\n    <div class=\"btn-group\"\n         [formGroupName]=\"model.id\"\n         [id]=\"elementId\"\n         [ngClass]=\"getClass('element', 'control')\">\n\n        <label *ngFor=\"let checkboxModel of model.group\" btnCheckbox class=\"btn\" role=\"button\"\n               [class.active]=\"checkboxModel.value\"\n               [formControlName]=\"checkboxModel.id\"\n               [id]=\"getCheckboxElementId(checkboxModel)\"\n               [innerHTML]=\"checkboxModel.label\"\n               [ngClass]=\"[getClass('element', 'control', checkboxModel)]\"></label>\n    </div>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapCheckboxGroupComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapCheckboxGroupComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapCheckboxGroupComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxGroupComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxGroupComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxGroupComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxGroupComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapCheckboxGroupComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapCheckboxGroupComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapCheckboxGroupComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapDatePickerComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.customEvent = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapDatePickerComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-datepicker",
                template: "<div [formGroup]=\"group\" class=\"input-group\">\n\n    <input bsDatepicker class=\"form-control\" #bsDatepicker=\"bsDatepicker\"\n           [autofocus]=\"model.autoFocus\"\n           [bsConfig]=\"model.getAdditional('bsConfig', {containerClass: model.getAdditional('containerClass', 'theme-green'), showWeekNumbers: model.getAdditional('showWeekNumbers', true)})\"\n           [datesDisabled]=\"model.getAdditional('datesDisabled', [])\"\n           [daysDisabled]=\"model.getAdditional('daysDisabled', [])\"\n           [formControlName]=\"model.id\"\n           [id]=\"elementId\"\n           [maxDate]=\"model.max\"\n           [minDate]=\"model.min\"\n           [name]=\"model.name\"\n           [ngClass]=\"getClass('element', 'control')\"\n           [outsideClick]=\"model.getAdditional('outsideClick', true)\"\n           [outsideEsc]=\"model.getAdditional('outsideEsc', true)\"\n           [placeholder]=\"model.placeholder\"\n           [placement]=\"model.getAdditional('placement', 'bottom')\"\n           [readonly]=\"model.readOnly\"\n           [required]=\"model.required\"\n           (bsValueChange)=\"onChange($event)\"\n           (onHidden)=\"onCustomEvent($event, 'onHidden')\"\n           (onShown)=\"onCustomEvent($event, 'onShown')\">\n\n    <div *ngIf=\"model.toggleIcon || model.toggleLabel\" class=\"input-group-append\">\n\n        <button *ngIf=\"model.toggleIcon\"\n                class=\"btn input-group-text\" type=\"button\"\n                (click)=\"bsDatepicker.toggle()\"><img [src]=\"model.toggleIcon\"/></button>\n        <button *ngIf=\"model.toggleLabel\"\n                class=\"btn input-group-text\" type=\"button\"\n                (click)=\"bsDatepicker.toggle()\">{{ model.toggleLabel }}</button>\n\n    </div>\n\n</div>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapDatePickerComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapDatePickerComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    customEvent: [{ type: Output }],
    focus: [{ type: Output }],
    bsDatePicker: [{ type: ViewChild, args: [BsDatepickerDirective, { static: true },] }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapDatePickerComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapDatePickerComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapDatePickerComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapDatePickerComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapDatePickerComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapDatePickerComponent.prototype.customEvent;
    /** @type {?} */
    DynamicNGxBootstrapDatePickerComponent.prototype.focus;
    /** @type {?} */
    DynamicNGxBootstrapDatePickerComponent.prototype.bsDatePicker;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapDatePickerComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapDatePickerComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapFormArrayComponent extends DynamicFormArrayComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.customEvent = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapFormArrayComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-form-array",
                template: "<ng-container [formGroup]=\"group\">\n\n    <div [formArrayName]=\"model.id\" [id]=\"elementId\" [ngClass]=\"getClass('element', 'control')\">\n\n        <div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\"\n             [formGroupName]=\"idx\" [ngClass]=\"[getClass('element', 'group'), getClass('grid', 'group')]\">\n\n            <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: groupModel\"></ng-container>\n\n            <dynamic-ngx-bootstrap-form-control *ngFor=\"let _model of groupModel.group\"\n                                                [context]=\"groupModel\"\n                                                [group]=\"array.at(idx)\"\n                                                [hidden]=\"_model.hidden\"\n                                                [layout]=\"layout\"\n                                                [model]=\"_model\"\n                                                [templates]=\"templates\"\n                                                [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model),\n                                                           getClass('element','children'), getClass('grid','children')]\"\n                                                (blur)=\"onBlur($event)\"\n                                                (change)=\"onChange($event)\"\n                                                (focus)=\"onFocus($event)\"\n                                                (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-ngx-bootstrap-form-control>\n\n            <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: groupModel\"></ng-container>\n\n        </div>\n\n    </div>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapFormArrayComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapFormArrayComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    templates: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    customEvent: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapFormArrayComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapFormArrayComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapFormArrayComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapFormArrayComponent.prototype.templates;
    /** @type {?} */
    DynamicNGxBootstrapFormArrayComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapFormArrayComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapFormArrayComponent.prototype.customEvent;
    /** @type {?} */
    DynamicNGxBootstrapFormArrayComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormArrayComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormArrayComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapFormGroupComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.customEvent = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapFormGroupComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-form-group",
                template: "<ng-container [formGroup]=\"group\">\n\n    <div role=\"group\" [formGroupName]=\"model.id\" [id]=\"elementId\" [ngClass]=\"getClass('element','control')\">\n\n        <dynamic-ngx-bootstrap-form-control *ngFor=\"let _model of model.group\"\n                                           [asBootstrapFormGroup]=\"true\"\n                                           [group]=\"control\"\n                                           [hidden]=\"_model.hidden\"\n                                           [layout]=\"layout\"\n                                           [model]=\"_model\"\n                                           [templates]=\"templates\"\n                                           [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model),\n                                                       getClass('element','children'), getClass('grid','children')]\"\n                                           (blur)=\"onBlur($event)\"\n                                           (change)=\"onChange($event)\"\n                                           (focus)=\"onFocus($event)\"\n                                           (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-ngx-bootstrap-form-control>\n    </div>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapFormGroupComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapFormGroupComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    templates: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    customEvent: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapFormGroupComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapFormGroupComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapFormGroupComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapFormGroupComponent.prototype.templates;
    /** @type {?} */
    DynamicNGxBootstrapFormGroupComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapFormGroupComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapFormGroupComponent.prototype.customEvent;
    /** @type {?} */
    DynamicNGxBootstrapFormGroupComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormGroupComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormGroupComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapInputComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapInputComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-input",
                template: "<div [formGroup]=\"group\" [class.input-group]=\"model.prefix || model.suffix\">\n\n    <div *ngIf=\"model.prefix\" class=\"input-group-prepend\">\n        <span class=\"input-group-text\" [innerHTML]=\"model.prefix\"></span>\n    </div>\n\n    <input [attr.accept]=\"model.accept\"\n           [attr.max]=\"model.max\"\n           [attr.min]=\"model.min\"\n           [attr.multiple]=\"model.multiple\"\n           [attr.step]=\"model.step\"\n           [autocomplete]=\"model.autoComplete\"\n           [autofocus]=\"model.autoFocus\"\n           [class.form-control]=\"model.inputType !== 'file'\"\n           [class.form-control-file]=\"model.inputType === 'file'\"\n           [class.is-invalid]=\"showErrorMessages\"\n           [dynamicList]=\"model.listId\"\n           [formControlName]=\"model.id\"\n           [id]=\"elementId\"\n           [maxlength]=\"model.maxLength\"\n           [minlength]=\"model.minLength\"\n           [name]=\"model.name\"\n           [ngClass]=\"getClass('element', 'control')\"\n           [pattern]=\"model.pattern\"\n           [placeholder]=\"model.placeholder\"\n           [readonly]=\"model.readOnly\"\n           [required]=\"model.required\"\n           [spellcheck]=\"model.spellCheck\"\n           [tabindex]=\"model.tabIndex\"\n           [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\"\n           [type]=\"model.inputType\"\n           (blur)=\"onBlur($event)\"\n           (change)=\"onChange($event)\"\n           (focus)=\"onFocus($event)\"/>\n\n    <div *ngIf=\"model.suffix\" class=\"input-group-append\">\n        <span class=\"input-group-text\" [innerHTML]=\"model.suffix\"></span>\n    </div>\n\n    <datalist *ngIf=\"model.hasList\" [id]=\"model.listId\">\n\n        <option *ngFor=\"let option of model.list$ | async\" [value]=\"option\">\n\n    </datalist>\n\n</div>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapInputComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapInputComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapInputComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapInputComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapInputComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapInputComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapInputComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapInputComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapInputComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapInputComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapRadioGroupComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapRadioGroupComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-radio-group",
                template: "<ng-container [formGroup]=\"group\">\n\n    <div btnRadioGroup class=\"btn-group\" role=\"radiogroup\"\n         [formControlName]=\"model.id\"\n         [id]=\"elementId\"\n         [ngClass]=\"getClass('element', 'control')\"\n         [tabindex]=\"model.tabIndex\"\n         (change)=\"onChange($event)\">\n\n        <label *ngFor=\"let option of model.options$ | async\" class=\"btn\" role=\"button\"\n               [btnRadio]=\"option.value\"\n               [disabled]=\"option.disabled\"\n               [innerHTML]=\"option.label\"\n               [ngClass]=\"[getClass('element', 'option'), getClass('grid', 'option')]\"></label>\n    </div>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapRadioGroupComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapRadioGroupComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapRadioGroupComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapRadioGroupComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapRadioGroupComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapRadioGroupComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapRadioGroupComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapRadioGroupComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapRadioGroupComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapRadioGroupComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapRatingComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapRatingComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-rating",
                template: "<ng-container [formGroup]=\"group\">\n\n    <rating [formControlName]=\"model.id\"\n            [id]=\"elementId\"\n            [max]=\"model.max\"\n            [ngClass]=\"getClass('element', 'control')\"\n            [readonly]=\"model.getAdditional('readonly', false)\"\n            (onHover)=\"onCustomEvent($event, 'onHover')\"\n            (onLeave)=\"onCustomEvent($event, 'onLeave')\"></rating>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapRatingComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapRatingComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapRatingComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapRatingComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapRatingComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapRatingComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapRatingComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapRatingComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapRatingComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapRatingComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapSelectComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapSelectComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-select",
                template: "<ng-container [formGroup]=\"group\">\n\n    <select class=\"form-control\"\n            [class.is-invalid]=\"showErrorMessages\"\n            [compareWith]=\"model.compareWithFn\"\n            [formControlName]=\"model.id\"\n            [id]=\"elementId\"\n            [name]=\"model.name\"\n            [ngClass]=\"getClass('element', 'control')\"\n            [required]=\"model.required\"\n            [tabindex]=\"model.tabIndex\"\n            (blur)=\"onBlur($event)\"\n            (change)=\"onChange($event)\"\n            (focus)=\"onFocus($event)\">\n\n        <option *ngFor=\"let option of model.options$ | async\"\n                [disabled]=\"option.disabled\"\n                [ngValue]=\"option.value\">{{ option.label }}</option>\n\n    </select>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapSelectComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapSelectComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapSelectComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapSelectComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapSelectComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapSelectComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapSelectComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapSelectComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapSelectComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapSelectComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapTextAreaComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapTextAreaComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-textarea",
                template: "<ng-container [formGroup]=\"group\">\n\n    <textarea class=\"form-control\"\n              [class.is-invalid]=\"showErrorMessages\"\n              [cols]=\"model.cols\"\n              [formControlName]=\"model.id\"\n              [id]=\"elementId\"\n              [maxlength]=\"model.maxLength\"\n              [minlength]=\"model.minLength\"\n              [name]=\"model.name\"\n              [ngClass]=\"getClass('element', 'control')\"\n              [placeholder]=\"model.placeholder\"\n              [readonly]=\"model.readOnly\"\n              [required]=\"model.required\"\n              [rows]=\"model.rows\"\n              [spellcheck]=\"model.spellCheck\"\n              [tabindex]=\"model.tabIndex\"\n              [wrap]=\"model.wrap\"\n              (blur)=\"onBlur($event)\"\n              (change)=\"onChange($event)\"\n              (focus)=\"onFocus($event)\"></textarea>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapTextAreaComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapTextAreaComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapTextAreaComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapTextAreaComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapTextAreaComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapTextAreaComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapTextAreaComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapTextAreaComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapTextAreaComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapTextAreaComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapTimePickerComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGxBootstrapTimePickerComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-timepicker",
                template: "<ng-container [formGroup]=\"group\">\n\n    <timepicker [arrowkeys]=\"model.getAdditional('arrowkeys', true)\"\n                [formControlName]=\"model.id\"\n                [hourStep]=\"model.getAdditional('hourStep', 1)\"\n                [id]=\"elementId\"\n                [max]=\"model.max\"\n                [min]=\"model.min\"\n                [mousewheel]=\"model.getAdditional('mousewheel', true)\"\n                [minuteStep]=\"model.getAdditional('minuteStep', 1)\"\n                [ngClass]=\"getClass('element', 'control')\"\n                [secondsStep]=\"model.getAdditional('secondsStep', 1)\"\n                [showMeridian]=\"model.meridian\"\n                [showSeconds]=\"model.showSeconds\"\n                [showSpinners]=\"model.getAdditional('spinners', true)\"></timepicker>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapTimePickerComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicNGxBootstrapTimePickerComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }],
    bsTimePicker: [{ type: ViewChild, args: [TimepickerComponent, { static: true },] }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapTimePickerComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapTimePickerComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapTimePickerComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapTimePickerComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapTimePickerComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapTimePickerComponent.prototype.focus;
    /** @type {?} */
    DynamicNGxBootstrapTimePickerComponent.prototype.bsTimePicker;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapTimePickerComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapTimePickerComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapFormControlContainerComponent extends DynamicFormControlContainerComponent {
    /**
     * @param {?} componentFactoryResolver
     * @param {?} layoutService
     * @param {?} validationService
     * @param {?} componentService
     * @param {?} relationService
     */
    constructor(componentFactoryResolver, layoutService, validationService, componentService, relationService) {
        super(componentFactoryResolver, layoutService, validationService, componentService, relationService);
        this.componentFactoryResolver = componentFactoryResolver;
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.componentService = componentService;
        this.relationService = relationService;
        this.asBootstrapFormGroup = true;
        this.context = null;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
        this.customEvent = new EventEmitter();
    }
    /**
     * @return {?}
     */
    get componentType() {
        return this.componentService.getCustomComponentType(this.model) || bootstrapUIFormControlMapFn(this.model);
    }
}
DynamicNGxBootstrapFormControlContainerComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-form-control",
                template: "<div [class.form-group]=\"(model.type !== 'GROUP' && asBootstrapFormGroup) || getClass('element', 'container').includes('form-group')\"\n     [formGroup]=\"group\"\n     [ngClass]=\"['ng-dynamic-forms-'+model.type.toLowerCase(), getClass('element', 'container'), getClass('grid', 'container')]\">\n\n    <label *ngIf=\"!isCheckbox && hasLabel\"\n           [for]=\"elementId\"\n           [innerHTML]=\"model.label\"\n           [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></label>\n\n    <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: model\"></ng-container>\n\n    <div [ngClass]=\"getClass('grid', 'control')\">\n\n        <ng-container #componentViewContainer></ng-container>\n\n        <small *ngIf=\"hasHint\" class=\"text-muted\" [innerHTML]=\"hint\" [ngClass]=\"getClass('element', 'hint')\"></small>\n\n        <div *ngIf=\"showErrorMessages\" [ngClass]=\"[getClass('element', 'errors'), getClass('grid', 'errors')]\">\n            <small *ngFor=\"let message of errorMessages\" class=\"invalid-feedback d-block\">{{ message }}</small>\n        </div>\n\n    </div>\n\n    <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: model\"></ng-container>\n\n    <ng-content></ng-content>\n\n</div>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapFormControlContainerComponent.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService },
    { type: DynamicFormComponentService },
    { type: DynamicFormRelationService }
];
DynamicNGxBootstrapFormControlContainerComponent.propDecorators = {
    contentTemplateList: [{ type: ContentChildren, args: [DynamicTemplateDirective,] }],
    inputTemplateList: [{ type: Input, args: ["templates",] }],
    asBootstrapFormGroup: [{ type: Input }],
    context: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }],
    customEvent: [{ type: Output, args: ["bsEvent",] }],
    componentViewContainerRef: [{ type: ViewChild, args: ["componentViewContainer", {
                    read: ViewContainerRef,
                    static: true
                },] }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.contentTemplateList;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.inputTemplateList;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.asBootstrapFormGroup;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.context;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.group;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.layout;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.model;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.focus;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.customEvent;
    /** @type {?} */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.componentViewContainerRef;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.validationService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.componentService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormControlContainerComponent.prototype.relationService;
}
/**
 * @param {?} model
 * @return {?}
 */
function bootstrapUIFormControlMapFn(model) {
    switch (model.type) {
        case DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
            return DynamicNGxBootstrapFormArrayComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
            return DynamicNGxBootstrapCheckboxComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            return DynamicNGxBootstrapCheckboxGroupComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
            return DynamicNGxBootstrapDatePickerComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_GROUP:
            return DynamicNGxBootstrapFormGroupComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_INPUT:
            return DynamicNGxBootstrapInputComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
            return DynamicNGxBootstrapRadioGroupComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_RATING:
            return DynamicNGxBootstrapRatingComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_SELECT:
            return DynamicNGxBootstrapSelectComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
            return DynamicNGxBootstrapTextAreaComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_TIMEPICKER:
            return DynamicNGxBootstrapTimePickerComponent;
        default:
            return null;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicNGxBootstrapFormComponent extends DynamicFormComponent {
    /**
     * @param {?} formService
     * @param {?} layoutService
     */
    constructor(formService, layoutService) {
        super(formService, layoutService);
        this.formService = formService;
        this.layoutService = layoutService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
        this.customEvent = new EventEmitter();
    }
}
DynamicNGxBootstrapFormComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ngx-bootstrap-form",
                template: "<dynamic-ngx-bootstrap-form-control *ngFor=\"let model of formModel; trackBy: trackByFn\"\n                                    [group]=\"formGroup\"\n                                    [hidden]=\"model.hidden\"\n                                    [layout]=\"formLayout\"\n                                    [model]=\"model\"\n                                    [ngClass]=\"[getClass(model,'element','host'), getClass(model,'grid','host')]\"\n                                    [templates]=\"templates\"\n                                    (blur)=\"onEvent($event, 'blur')\"\n                                    (change)=\"onEvent($event, 'change')\"\n                                    (focus)=\"onEvent($event, 'focus')\"\n                                    (bsEvent)=\"onEvent($event, 'custom')\"></dynamic-ngx-bootstrap-form-control>\n"
            }] }
];
/** @nocollapse */
DynamicNGxBootstrapFormComponent.ctorParameters = () => [
    { type: DynamicFormService },
    { type: DynamicFormLayoutService }
];
DynamicNGxBootstrapFormComponent.propDecorators = {
    formGroup: [{ type: Input, args: ["group",] }],
    formModel: [{ type: Input, args: ["model",] }],
    formLayout: [{ type: Input, args: ["layout",] }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }],
    customEvent: [{ type: Output, args: ["bsEvent",] }],
    templates: [{ type: ContentChildren, args: [DynamicTemplateDirective,] }],
    components: [{ type: ViewChildren, args: [DynamicNGxBootstrapFormControlContainerComponent,] }]
};
if (false) {
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.formGroup;
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.formModel;
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.formLayout;
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.blur;
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.change;
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.focus;
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.customEvent;
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.templates;
    /** @type {?} */
    DynamicNGxBootstrapFormComponent.prototype.components;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormComponent.prototype.formService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGxBootstrapFormComponent.prototype.layoutService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFormsNGxBootstrapUIModule {
}
DynamicFormsNGxBootstrapUIModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    ReactiveFormsModule,
                    BsDatepickerModule,
                    ButtonsModule,
                    RatingModule,
                    TimepickerModule,
                    TextMaskModule,
                    DynamicFormsCoreModule
                ],
                declarations: [
                    DynamicNGxBootstrapCheckboxComponent,
                    DynamicNGxBootstrapCheckboxGroupComponent,
                    DynamicNGxBootstrapDatePickerComponent,
                    DynamicNGxBootstrapFormArrayComponent,
                    DynamicNGxBootstrapFormComponent,
                    DynamicNGxBootstrapFormControlContainerComponent,
                    DynamicNGxBootstrapFormGroupComponent,
                    DynamicNGxBootstrapInputComponent,
                    DynamicNGxBootstrapRadioGroupComponent,
                    DynamicNGxBootstrapRatingComponent,
                    DynamicNGxBootstrapSelectComponent,
                    DynamicNGxBootstrapTextAreaComponent,
                    DynamicNGxBootstrapTimePickerComponent
                ],
                entryComponents: [
                    DynamicNGxBootstrapCheckboxComponent,
                    DynamicNGxBootstrapCheckboxGroupComponent,
                    DynamicNGxBootstrapDatePickerComponent,
                    DynamicNGxBootstrapFormArrayComponent,
                    DynamicNGxBootstrapFormGroupComponent,
                    DynamicNGxBootstrapInputComponent,
                    DynamicNGxBootstrapRadioGroupComponent,
                    DynamicNGxBootstrapRatingComponent,
                    DynamicNGxBootstrapSelectComponent,
                    DynamicNGxBootstrapTextAreaComponent,
                    DynamicNGxBootstrapTimePickerComponent
                ],
                exports: [
                    DynamicFormsCoreModule,
                    DynamicNGxBootstrapCheckboxComponent,
                    DynamicNGxBootstrapCheckboxGroupComponent,
                    DynamicNGxBootstrapDatePickerComponent,
                    DynamicNGxBootstrapFormArrayComponent,
                    DynamicNGxBootstrapFormComponent,
                    DynamicNGxBootstrapFormControlContainerComponent,
                    DynamicNGxBootstrapFormGroupComponent,
                    DynamicNGxBootstrapInputComponent,
                    DynamicNGxBootstrapRadioGroupComponent,
                    DynamicNGxBootstrapRatingComponent,
                    DynamicNGxBootstrapSelectComponent,
                    DynamicNGxBootstrapTextAreaComponent,
                    DynamicNGxBootstrapTimePickerComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DynamicFormsNGxBootstrapUIModule, DynamicNGxBootstrapCheckboxComponent, DynamicNGxBootstrapCheckboxGroupComponent, DynamicNGxBootstrapDatePickerComponent, DynamicNGxBootstrapFormArrayComponent, DynamicNGxBootstrapFormComponent, DynamicNGxBootstrapFormControlContainerComponent, DynamicNGxBootstrapFormGroupComponent, DynamicNGxBootstrapInputComponent, DynamicNGxBootstrapRadioGroupComponent, DynamicNGxBootstrapRatingComponent, DynamicNGxBootstrapSelectComponent, DynamicNGxBootstrapTextAreaComponent, DynamicNGxBootstrapTimePickerComponent, bootstrapUIFormControlMapFn };
//# sourceMappingURL=ui-ngx-bootstrap.js.map
